% This function simulates a set of p-values, then applies the FDR method on
% them, and calculate statistics of the number of rejections (R), false
% rejections (V) and their ratio (V/R^+)
function [VR_hist V_moments R_moments FDR_moments] = simulate_VR_dist(iters,m,m0,mu_gap,dep_flag,rho,fdr_str,q)

pvals_vec = simulate_pvals(iters,m,m0,mu_gap,dep_flag,rho); % simulate p-vals

[R V] = FDR_mat_main(pvals_vec, q, fdr_str, [], m0); % assume no auxillary u for now


V_moments = [mean(V) var(V)]; R_moments = [mean(R) var(R)]; FDR_moments = [mean(V./max(R,1)), var(V./max(R,1))];  

VR_hist = hist2d ([R V], -0.5:1:max(R)+1, -0.5:1:max(R)+1) ./ iters;
fig_flag = 0;
if(fig_flag)
%    figure; Plot2dHist(VR_hist, 0:max(V)+1, 0:max(R)+1, 'V', 'R', '(V,R) two-dim histogram');     % not so clear plot
    figure;
    if(length(VR_hist) == 1)
        imagesc(VR_hist);
    else
        imagesc(VR_hist, [min(VR_hist(:)) max(max(VR_hist(2:end,:)))]);
    end
    xlabel('V(+1)'); ylabel('R(+1)'); title(['(V,R) two-dim histogram. P(V=0,R=0) is actually ' num2str(VR_hist(1,1))]); colorbar;
end

    
